<script lang="ts">
	import { run } from 'svelte/legacy';

	import { createEventDispatcher } from 'svelte'
	import ChipListManager from './ChipListManager.svelte'
	import Select from './Select.svelte'


	interface Props {
		backgroundColour?: string;
		title?: string;
		description?: string;
		placeholder?: string;
		text?: string;
		name: string;
		style?: string;
		items?: string[];
		selectedItems?: string[];
	}

	let {
		backgroundColour = 'rgba(0,0,0,0.25)',
		title = 'Title',
		description = 'Description of this setting item',
		placeholder = 'Enter a distance in km',
		text = '',
		name,
		style = '',
		items = [],
		selectedItems = $bindable([])
	}: Props = $props();

	const dispatch = createEventDispatcher()

	export function resetSelection() {
		selectedItems = []
		pickableItems = items.slice()
	}

	let postableItems: string = $state('')
	let pickableItems: string[] = $state(items.slice())

	run(() => {
		if (items) {
			items.forEach((o) => {
				if (selectedItems.includes(o)) return
				if (pickableItems.includes(o)) return
				pickableItems.push(o)
			})

			for (let i = 0; i < pickableItems.length; i++) {
				const o = pickableItems[i]
				if (items.includes(o)) continue
				pickableItems.splice(i, 1)
			}

			for (let i = 0; i < selectedItems.length; i++) {
				const o = selectedItems[i]
				if (items.includes(o)) continue
				selectedItems.splice(i, 1)
			}

			pickableItems = pickableItems
			selectedItems = selectedItems
		}
	});

	function selectedItem(e: CustomEvent<{ item: string }>) {
		selectedItems.push(e.detail.item)
		selectedItems = selectedItems
		dispatch('add', { item: e.detail.item })
		formatForPost()
	}

	function deselectItem(e: CustomEvent<{ item: string }>) {
		selectedItems = selectedItems.filter((o) => o !== e.detail.item)
		pickableItems.push(e.detail.item)
		pickableItems = pickableItems
		dispatch('remove', { item: e.detail.item })
		formatForPost()
	}

	function formatForPost() {
		postableItems = JSON.stringify(selectedItems)
	}
</script>

<div id="box" style="--bgColour:{backgroundColour}; --content:'{placeholder}' {style}">
	<h3>{title}</h3>
	<h4>{description}</h4>

	<input type="hidden" {name} bind:value={postableItems}>

	<ChipListManager items={selectedItems} manualAdd={false} on:remove={deselectItem} style="min-height: 58px;" />
	<Select bind:items={pickableItems} {text} on:add={selectedItem} />
</div>

<style>
	#box {
		display: grid;
		grid-template-columns: 1fr;
		grid-template-rows: auto auto auto;
		grid-template-areas: 'title' 'description' 'entry';
		background-color: var(--bgColour);
		border-radius: 5px;
		margin-top: 5px;
		margin-bottom: 1rem;
		margin-left: 1rem;
		margin-right: 1rem;
		padding-left: 1rem;
		padding-right: 1rem;
		padding-bottom: 1rem;
	}

	h3 {
		margin-top: 1rem;
		grid-area: title;
		text-align: left;
		color: #cbcbcb;
		font-size: 1em;
	}

	h4 {
		grid-area: description;
		margin-top: 0px;
		color: #656565;
		text-align: left;
		font-size: 0.9em;
	}
</style>
